/*---------------------------------------------------------+
I                                                          I
I  Programme         : Programme Minimum de communication  I
I                                                          I
I  Creation          : 22 Mars      1991                   I
I  Derniere revision : 14 Septembre 1992                   I
I                                                          I
I  Auteur            : G. Grimonprez                       I
I                                                          I
+---------------------------------------------------------*/

#define BANDEAU "RESEAUX : COMMIN, Version 3.0, 18 Septembre 1997"

/*---------------------------------------------------------+
I                    INCLUDES  GENERAUX                    I
+---------------------------------------------------------*/

#include <stdio.h>
#include <setjmp.h>
#include <process.h>
#include <string.h>

#include "modres.h"

/*---------------------------------------------------------+
I                      DECLARATIONS GLOBALES               I
+---------------------------------------------------------*/

/*---------------------------------------------------------+
I                    TRAITEMENT DES ERREURS                I
+---------------------------------------------------------*/

jmp_buf point_de_retour;

void erreur(char *message)
{

 printf("\nERREUR : %s\n",message);
 longjmp(point_de_retour,0);
}

/*----- TRAITER_RECEPTION_CLAVIER ------------------------*/

void traiter_reception_clavier(char c,BOOLEAN b)
{

 if(b) {
   switch(c) {
          case ALT_X:
                     break;
	  default   :
		     erreur("Caractere clavier invalide");
		     break;
	  }
   }
 else {
    putch(c);
    emission_octet(c);
    }
}

/*----- TRAITER_RECEPTION_PORT_SERIE ---------------------*/

void traiter_reception_port_serie(char c)
{

 putch(c);

}

/*----- MAIN ---------------------------------------------*/

void main(void)
{
 char    car_clavier,car_recu;
 BOOLEAN b_special;

 printf("%s\n",BANDEAU);
 init_controleur(COM3,1200,8,1,SANS,2);
 setjmp(point_de_retour);
 car_clavier=' ';
 b_special=FALSE;
 do {
    if(lire_clavier(&car_clavier,&b_special))
       traiter_reception_clavier(car_clavier,b_special);
    if(recevoir_octet(&car_recu))
       traiter_reception_port_serie(car_recu);
    } while(car_clavier!=ALT_X || !b_special);
 restaure_controleur();
 exit(1);                           /* a cause du setjmp */
}
